<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 10-29-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

//start the session
session_start();
if (!isset($_SESSION['generated'])) { 
   session_regenerate_id(); 
   $_SESSION['generated'] = true;
}

function curPageName()
{
	return substr($_SERVER["SCRIPT_NAME"],strrpos($_SERVER["SCRIPT_NAME"],"/")+1);
}

function safeDir($path)
{
	$dirname = dirname($path);
	return $dirname == '/' ? '' : $dirname;
}

function pageGentime()
{
    static $start_time;
    if ($start_time == 0) {
		$start_time = microtime(true);
	} else {
		$end_time = (string)(microtime(true)-$start_time);
		return round($end_time,3);
	}
}
pageGentime();

//debuging
//ini_set('display_errors', 0);
//error_reporting(E_ALL|E_STRICT);
//ini_set('log_errors', true);
//silent -> 0 <> verbose -> 1 <> non-verbose -> 2 <> redirect -> 3
$setSQLDebug = 0;

include_once 'db.inc.php';

//Get enviorment settings from DB
function getEnvSettings()
{
	$sql = "SELECT * FROM env_settings";
	$res = sqlQuery($sql);
	if (empty($res)) {
		die (DATABASE_EMPTY_ERROR);
	}

	if(sqlErrorReturn()) {
		sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	}

	$a_row = sqlFetchAssoc($res);
	if ($a_row)
		return $a_row;
}

//map each field to the value stored in the database
$env = getEnvSettings();
foreach ($env as $field => $value ) {
	${$field} = $value;
}

//set define for template used throughout the site and setup base url
DEFINE("TEMPLATE_DIR","$template");
DEFINE("SERVER_PATH","http://" . $_SERVER['SERVER_NAME'] ."" . safeDir($_SERVER['PHP_SELF']) . "/");

//setup referers.. domains/ips that you will allow valid referer for form scripts
//$referers = array('example.com','www.example.com');

//for php5 users set the default timezone if not set in your php ini
//http://www.php.net/manual/en/timezones.php
$ver = phpversion();
if ($ver >= 5) {
	if (!@date_default_timezone_set(date_default_timezone_get())) {
		date_default_timezone_set("$site_timezone");
	}
}

//if a remember me cookie was set on a previous visit check for cookie
if (isset($_COOKIE["user"])) {
	$_COOKIE = codeClean($_COOKIE);
	if (verifyCookie($_COOKIE["user"],$_COOKIE["pass"])) {
		session_regenerate_id();
		$_SESSION["user"] = $_COOKIE["user"];
        $_SESSION["pass"] = $_COOKIE["pass"];
		$_SESSION["logged_in"] = 1;

		if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"]))
			$_SESSION["admin"] = 1;
		if (checkIfSeller($_SESSION["user"],$_SESSION["pass"]))
			$_SESSION["seller"] = 1;
  	}
}

//check for logged in user or guest to poulate last active data
if (isset($_SESSION["user"])) {
	lastActive($_SESSION["user"]);
} else {
	lastActive('guest');
}

//check for maintenace mode
if ($maint_mode) {
	if (!isset($_SESSION["admin"])) {
		if ('login.php' !== curPageName()) {
			die ("<h1>The System is undergoing maintenance. <a href=\"login.php\">Admin Login</a></h1>");
		}
	}
}

?>