<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 12-31-2011 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

include_once 'env.inc.php';

//Check if magic qoutes is on then stripslashes if needed
function codeClean($var)
{
	$output = '';
    if (is_array($var)) {
		foreach($var as $key => $val) {
			$output[$key] = codeClean($val);
    	}
    } else {
		$var = strip_tags(trim($var));
		if (function_exists("get_magic_quotes_gpc")) {
			$output = sqlEscapeString(get_magic_quotes_gpc() ? stripslashes($var) : $var);
		} else {
			$output = sqlEscapeString($var);
		}
	}
	return $output;
}

function viewOnPage($var)
{
	$output = '';
	if (is_array($var)) {
		foreach($var as $key => $val) {
			$output[$key] = viewOnPage($val);
    	}
    } else {
    	$var = htmlentities(trim($var), ENT_NOQUOTES, "UTF-8");
		if (function_exists("get_magic_quotes_gpc")) {
		   	$output = get_magic_quotes_gpc() ? stripslashes($var) : $var;
		} else {
			$output = $var;
		}
	}
	return $output;
}

// function to check the referer for security reasons.
function checkReferer($referers) 
{
	$time = date('Y-m-d h:i');
	$referer = $_SERVER["HTTP_REFERER"];

   	//if the referrer is empty you will be redirected
	if (empty($referer)) {
		error_log(" $time Empty Referer. '" . $_SERVER["REMOTE_ADDR"] . "' \r\n", 3, "error.txt");
		header("Location: index.php");
		return false;
	} else {
		@list($remove,$stuff) = explode('//',$referer,2);
		@list($home,$stuff) = explode('/',$stuff,2);

		if (in_array($home,$referers)) {
			//print "".__LINE__." $home <-home $referer <-referer";
			return true;
		}

		//if you get this far you have not met the criteria and will be redirected
		//if someone comes from a place other then in our referers list
		//set them in the right spot on our domain
		error_log(" $time Illegal Referer. '" . $_SERVER["HTTP_REFERER"] . "' \r\n", 3, "error.txt");
		header("Location: index.php");
		return false;
	}
}

//check status for use activation
function getActivationDefaults()
{
	global $use_listing_approval;
	
	if ($use_listing_approval) {
		//check if not an admin and set the proper status
		if (!isset($_SESSION["admin"])) {
			//if not admin set to 0 so listing has to be reapproved
			return 0;
		} else {
			//else we must be an admin so set to approved automaticlly
			return 1;
		}
	} else {
		//if use listing activation is turned off defaults to activated by default
		return 1;
	}
}

//Login functions
function verifyLogin($user,$pass)
{
	$num=0;
	if (isset($user) && isset($pass)) {
		//Encrypt password for database verification
		$salt = 's+(_a*';
		$pass = md5($pass.$salt);

		$sql = "SELECT pass FROM users WHERE pass = '" . $pass . "' AND user = '" . $user ."'";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
	}

	if ($num > 0)
		return true;
	return false;	
}

function verifyCookie($user,$pass)
{
	$num=0;
	if (isset($user) && isset($pass)) {
		$sql = "SELECT pass FROM users WHERE pass = '" . $pass . "' AND user = '" . $user ."'";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
	}

	if ($num > 0)
		return true;
	return false;	
}

//Page auth function
function checkPrivs()
{
	if (!empty($_SESSION["admin"])) {
		return 'admin';
	} elseif (!empty($_SESSION["seller"])) {
		return 'seller';
	} else {
		return 'user';
	}
}

function checkIfAdmin($user,$pass)
{
	$num=0;
	if (isset($user) && isset($pass)) {
		$sql = "SELECT pass FROM users WHERE pass = '" . $pass . "' AND user = '" . $user ."' AND user_level = 9 ";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
	}
	
	if ($num > 0)
		return true;
	return false;	
}

function checkIfSeller($user,$pass)
{
	$num=0;
	if (isset($user) && isset($pass)) {
		$sql = "SELECT pass FROM users WHERE pass = '" . $pass . "' AND user = '" . $user ."' AND user_level = 2 ";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
	}

	if ($num > 0)
		return true;
	return false;	
}

function logoff()
{
	global $visitor_tracking;

	//when logging off delete from the online users tables if user tracking is enabled
	if (!empty($visitor_tracking) && isset($_SESSION["user"])) {
		$sql = "DELETE FROM onlineusers WHERE user = '" . $_SESSION["user"] . "'";
		$del = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	}

	// remove all session variables and destroy session
	unset($_SESSION["user"]);
	unset($_SESSION["pass"]);
	unset($_SESSION["logged_in"]);
	unset($_SESSION["admin"]);

	session_destroy();

	if (isset($_COOKIE["user"])) {
		setcookie("user", NULL, time()-3600);
		setcookie("pass", NULL, time()-3600);
	}

	if (isset($_COOKIE[session_name()])) {
    	setcookie(session_name(), NULL, time()-3600);
	}

	// redirect them to anywhere you like.
	header("Location: login.php");
}

//Update account functions
function getUserRecords($user)
{
	$sql = "SELECT * FROM users WHERE user = '" . $user . "'"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		$records[$c]["id"] = $a_row["id"];
		$records[$c]["email"] = $a_row["email"];
		$records[$c]["user"] = $a_row["user"];
		$records[$c]["company_name"] = $a_row["company_name"];
		$records[$c]["first_name"] = $a_row["first_name"];
		$records[$c]["last_name"] = $a_row["last_name"];
		$records[$c]["phone"] = $a_row["phone"];
		$records[$c]["alt_phone"] = $a_row["alt_phone"];
		$records[$c]["fax"] = $a_row["fax"];
		$records[$c]["image"] = $a_row["image"];
		$records[$c]["country"] = $a_row["country"];
		$records[$c]["address"] = $a_row["address"];
		$records[$c]["city"] = $a_row["city"];
		$records[$c]["state"] = $a_row["state"];
		$records[$c]["zip"] = $a_row["zip"];
		$records[$c]["reg_date"] = $a_row["reg_date"];
		$records[$c]["image"] = $a_row["image"];
	++$c;
    }
	if (!empty($records))
	    return $records;
}

function updateUser($user, $email, $company_name, $first_name, $last_name, $phone, $alt_phone, $fax, $country, $address, $city, $state, $zip)
{
	if (!validateEmail($email))	{
		return 1;
	} elseif (!validatePhone($phone)) {
		return 2;
	} elseif (!validateName($first_name)) {
		return 3;
	} elseif (!validateName($last_name)) {
		return 4;
	} else {
		// Get remote IP
		$ipaddress = ipConvertLong(getenv('REMOTE_ADDR'));
		$sql = "UPDATE users SET ipaddress = " . $ipaddress . ", email = '" . $email . "', company_name = '" . $company_name . "', first_name = '" . $first_name . "', last_name = '" . $last_name . "', phone = '" . $phone . "', alt_phone = '" . $alt_phone . "', fax = '" . $fax . "', country = '". $country . "', address = '". $address . "', city = '". $city . "', state = '". $state . "', zip = '". $zip . "' WHERE user = '" . $user . "'";		
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	return 99;
	}
}

//Reset password functions
function updatePass($user,$pass)
{
	//Encrypt password for database
	$salt = 's+(_a*';
	$new_password = md5($pass.$salt);
	//if user logged in change their session password 
	if (isset($_SESSION["pass"])) {
		$_SESSION["pass"] = "$new_password";
	}

	//if remember me function already set
	//change cookie for remember me
	if (isset($_COOKIE["pass"])) {
		setcookie("pass", "$new_password", time() + (60*60*24*30));
	}

	//perform sqlQuery and update user info in the database
	$sql = "UPDATE users SET pass = '" . $new_password . "' WHERE user = '" . $user . "'";
 	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
}

function generatePassword($len)
{
	$password = "";
	$char = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

	$c=0;
	while ($c <= $len) {
		$random = rand(1,strlen($char));
		$password .= substr($char,$random -1,1);
	++$c;
	} 

	if (!empty($password))
	    return $password;//echo $password;
}

//validater functions
function validatePhone($phone)
{
	if (preg_match('!^((\+\d{1,3}(-| )?\(?\d\)?(-| )?\d{1,5})|(\(?\d{2,6}\)?))(-| )?(\d{3,4})(-| )?(\d{3,4})(( x| ext)\d{1,5}){0,1}$!', $phone))
		return true;
	return false;
}

function validateName($name)
{
	$first = substr($name, 0, 1);
	if ($first == '.' || $first == '-' || $first == '_') {
		return false;
	}

	//if slashes are added remove them since this doesn't go in the db and we don't want names with \
	$name = str_replace('\\', '', $name);
	if (preg_match('!^[a-zA-Z\']+$!', $name))
    	return true;
	return false;
}

function validateUsername($user)
{
	$first = substr($user, 0, 1);
	if ($first == '.' || $first == '-' || $first == '_') {
		return false;
	}
	
	if (preg_match('!^[a-zA-Z0-9._-]{5,60}$!', $user))
    	return true;
	return false;
}

function validateEmail($email)
{
	if (preg_match("!^[a-zA-Z0-9]+([_\\.-][a-zA-Z0-9]+)*@([a-z0-9]+([\.-][a-z0-9]+)*)+\\.[a-z]{2,4}$!", $email))
   		return true;
	return false;
}

//Registration functions
function checkIfUser($user)
{
	$sql = "SELECT user FROM users WHERE user = '" . $user ."' ";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);

	if ($num > 0)
		return true;
	return false;	
}

function checkIfEmail($email)
{
	if (isset($_SESSION["user"])) {
		$user = $_SESSION["user"];
		$sql = "SELECT * FROM users WHERE email = '" . $email ."' AND user = '" . $user ."'";
	} else {
		$sql = "SELECT * FROM users WHERE email = '" . $email ."' ";
	}
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);
	
	if ($num > 0)
		return true;
	return false;	
}

//start user contributed functions verify by email[leowmjw]
function generateConfirmationID($user, $timestamp)
{
	$sql = "SELECT id FROM users WHERE user = '" . $user . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	// if cannot get anything back; croak and die
	if ($a_row = sqlFetchArray($res)) {
		return $timestamp . "-" . $a_row["id"];
	} else {
		return false;
	}
}

function updateUsername($uid, $user)
{
	$uid = codeClean($uid);
	$user = codeClean($user);
	$sql = "UPDATE users SET user = '" . $user . "', activated = 1 WHERE id = '" .$uid . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	// If succeed; return TRUE, else FALSE!!
	if (!empty($res))
		return $res;
	return false;
}

function getUsername($uid)
{
	$uid = codeClean($uid);
	$sql = "SELECT user FROM users WHERE id = '" . $uid ."'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	// if cannot get anything back; croak and die
	if ($a_row = sqlFetchArray($res))
		return $a_row["user"];
	return false;
}

function activateProfile($confirmationID)
{
	// Purpose: Activate a registered Profile based on a unique confirmation number
	// Returns: TRUE if all check passes and username is updated correctly
	//          FALSE if any check fails or anything bad happens.
	//          Reasons to fail:
	//              timestamp does not match
	//              wrong format
	// Check that it fits the regexp for confirmationID -- ^[0-9]-[0-9]+$ => ^{timestamp}-{uid}$
	// [bkeep] Changed if (!eregi("^([0-9]+)-([0-9]+)$", $confirmationID, $regs)) { 
	if (!preg_match_all("!^([0-9]+)-([0-9]+)$!", $confirmationID, $regs)) {
		//$error_code = "Confirmation ID - $confirmationID - is not valid!";
		//return false;
		return 1;
	}
	// If it fits the profile; split the string to the timestamp component and uid component
	// First parenthesis is for timestamp; second parenthesis is for user ID
	$timestamp = $regs[1][0];
	$uid = $regs[2][0];

	// Pull out the record based on the uid and compare if it fits the regexp
	if ($user = getUsername($uid)) {
		// If does not fit the pattern; possibly this username has already been activated!!!
		// [bkeep] Changed if (!eregi("^<([0-9]+)>-([A-Z0-9]{5,20})$", $user, $regs)) {
		if (!preg_match_all("!^<([0-9]+)>-([a-zA-Z0-9._-]{5,60})$!", $user, $regs)) {
			//$error_code = "The username - $user - has been activated!  Please login with this username!";
			//return false;
			return 2;
		}

		// Now we have the correct username
		// Pull out the original username component from the matching regexp
		// First parenthesis is for timestamp; second parenthesis is for username
		$stored_timestamp = $regs[1][0];
		$user = $regs[2][0];

		// Update DB with correct username if timestamp matches
		if ($timestamp == $stored_timestamp) {
			// If $user already exists in the system; must re-register!
			$res = updateUsername($uid, $user);
			if (!$res) {
				//$error_code = "User $user already exists on the system.  " . 'Please re-register at the <a href="register.php">Registration Page</a> with another username.';
				//return false;
				return 3;
			} else {
				//return $res;
				return 99;
			}
		} else {
			//$error_code = "The timestamp does not match with the records!";
			//return false;
			return 4;
		}
	} else {
		//$error_code = "Invalid uid!";
		//return false;
		return 5;
	}
}
//end user contributed function [leowmjw]

function registerUser($user, $pass, $email, $company_name, $first_name, $last_name, $phone, $alt_phone, $fax, $country, $address, $city, $state, $zip, $agree)
{
	global $admin_name;
	global $admin_email;
	global $default_user_level;
	global $use_verify_email;
	global $use_user_approval;

	$error = '';
	//todo work out better error handling routine
	if (checkIfUser($user))	{
		$error[] = 1;
	} 
	if (!validateEmail($email)) {
		$error[] = 2;
	} 
	if (!validateUsername($user)) {
		$error[] = 3;
	} 
	if (checkIfEmail($email)) {
		$error[] = 4;
	} 
	if (empty($agree)) {
		$error[] = 5;
	} 
	if (!validatePhone($phone)) {
		$error[] = 6;
	} 
	if (!validateName($first_name)) {
		$error[] = 7;
	} 
	if (!validateName($last_name)) {
		$error[] = 8;
	}
	if ($error) {
		return $error;
	} else {
		//if blank password one is generated then the details are emailed
		if (empty($pass)) {
			$pass = generatePassword(6);

			// If email verification functionality is enabled
			if ($use_verify_email) { 
				$body = preg_replace("!%USERNAME%!", "$user", ACCT_SIGNUP_BODY_VERIFY);
			} else {
 				$body = preg_replace("!%USERNAME%!", "$user", ACCT_SIGNUP_BODY);
			}
		} else {
			// If email verification functionality is enabled
			if ($use_verify_email) {
				$body = preg_replace("!%USERNAME%!", "$user", ACCT_SIGNUP_BODY_WPASS_VERIFY);
			} else {
				$body = preg_replace("!%USERNAME%!", "$user", ACCT_SIGNUP_BODY_WPASS);
			}
		}

		//build email to be sent from lang file
		$body = preg_replace("!%PASSWORD%!", "$pass", $body);
		$body = preg_replace("!%URL%!", SERVER_PATH."login.php", $body);
		$subject = preg_replace("!%URL%!", SERVER_PATH, ACCT_SIGNUP_SUBJECT);
		$subject = preg_replace("!%USERNAME%!", "$user", $subject);
		//The last part of the email is at the bottom!!

	  	// Get remote IP
		$ipaddress = ipConvertLong(getenv('REMOTE_ADDR'));
		$reg_date = date("Y-m-d H:i:s");

	  	//Encrypt password for database
	    $salt = 's+(_a*';
		$pass = md5($pass.$salt);

		//Set the default activated status if not using the verify email functions
		$activated = 1;
		//Set the default user approval status
		$approved = 1;
		
		// If user approval functionality is enabled
		if ($use_user_approval)
			$approved = 0;

		// If email verification functionality is enabled
		if ($use_verify_email) {
			// Mangle username with timestamp to make sure user confirm e-mail address.
			// After e-mail is confirmed; this username will be unmangled
			// This will also set the actived status to 0 awaiting a proper verification 
			$timestamp = time();
			$user = "<" . $timestamp . ">-" . $user;
			$activated = 0;
		}

		//get default user level set by admin and insert
		$user_level = $default_user_level;
		$sql = "INSERT INTO users (ipaddress,user,pass,email,company_name,first_name,last_name,phone,alt_phone,fax,country,address,city,state,zip,reg_date,user_level,activated,approved) VALUES (" . $ipaddress . ", '" . $user . "','" . $pass . "', '" . $email . "', '" . $company_name . "', '" . $first_name . "', '" . $last_name . "', '" . $phone . "', '" . $alt_phone . "', '" . $fax . "', '" . $country . "', '" . $address . "', '" . $city . "', '" . $state . "', '" . $zip . "', '" . $reg_date . "', " . $user_level . ", " . $activated . ", " . $approved . ")"; 
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

		// If email verification functionality is enabled
		if ($use_verify_email) {
			// ConfirmationID ==> timestamp.uid
			$cid = generateConfirmationID($user, $timestamp);
			// Put in the correctly generated confirmation URL into the
			//$body = preg_replace("!%CONFIRMURL%!", "$site_url/login.php?verify=$cid", $body);
			$body = preg_replace("!%CONFIRMURL%!", OAC_SERVER_PATH."login.php?verify=$cid", $body);
		}
 
		// Send off the completed mail to user; with username and password in it.
		// Also will have confirmation URL if feature: validate email enabled.

		sendEmail($email,$subject,$body,$admin_name,$admin_email);
		return 99;
	}
}

//last avtive
function lastActive($user)
{
	global $visitor_tracking;

	$current_time = date("Y-m-d H:i:s");
	$ipaddress = ipConvertLong(getenv('REMOTE_ADDR'));

	//check if user is a guest or a logged in user
	//if logged in update the last active time in the users table and if activated the onlineusers table
	//if not logged in update the onlineusers table with correct guest info
	//checks for guest user first then checks if a user is logged in

	if (!empty($visitor_tracking) && $user == 'guest') {
		//guest is viewing check if already listed using their ip address in onlineusers table
		$sql = "SELECT ipaddress FROM onlineusers WHERE user = '" . $user . "' AND ipaddress = " . $ipaddress . "";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
		if ($num > 0) {
			//if check showed result then perform an update to the onlineusers table
			$sql = "UPDATE onlineusers SET last_active = '" . $current_time . "', ipaddress = " . $ipaddress . " WHERE user = '" . $user . "' AND ipaddress = " . $ipaddress . "";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		} else {
			//if check failed insert result in to the onlineusers table
			$sql = "INSERT INTO onlineusers (user,last_active,ipaddress) VALUES ('" . $user . "', '" . $current_time . "', " . $ipaddress . ")";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		} 
	} elseif (!empty($visitor_tracking) && $user == $_SESSION["user"]) {
		//user is logged in check if they are listed in onlineusers table
		$sql = "SELECT user FROM onlineusers WHERE user = '" . $user . "'";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
		if ($num > 0) {
			//if check showed result then perform the update to the tables users and onlineusers
			$sql = "UPDATE users,onlineusers SET users.last_active = '" . $current_time . "', onlineusers.last_active = '" . $current_time . "' WHERE onlineusers.user = users.user";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		} else {
			//if check failed insert result in the onlineusers table
			$sql = "INSERT INTO onlineusers (user,last_active,ipaddress) VALUES ('" . $user . "', '" . $current_time . "', " . $ipaddress . ")";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		}
	} else {
		//not using the visitor tracking feature so just update the last_active field for the user
		$sql = "UPDATE users SET last_active = '" . $current_time . "' WHERE user = '" . $user . "' ";
	}

	//perform some cleanup actions for the onlineusers table if visitor_tracking is enabled
	if (!empty($visitor_tracking)) {
		//now that we have checked the guest user or logged in user perform some cleanups of old dead userdata
		$sql = "SELECT * FROM onlineusers";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);

		//print "".__LINE__." $sql, $num, I am $user this is my ip $ipaddress<br />";
		if ($num > 0) {
			while ($a_row = sqlFetchArray($res)) {
				$id = $a_row["id"];
		 		$last_active_time = $a_row["last_active"];
				//print $last_active_time;
				
				//if last active time is less than last active time plus 5 minutes
				$last_active_timestamp = strtotime($last_active_time);
				$current_timestamp = strtotime(date("Y-m-d H:i:s"));
				//print "<br />$last_active_timestamp";
				//print "<br />$current_timestamp";

				$time_diff = ($current_timestamp-$last_active_timestamp);
				//print "<br />$time_diff";

				$time_diff_minutes = date("i",$time_diff);
				//print "<br /> $time_diff_minutes<br />";
				
				//delete the row from onlineusers if the current time is greater than last_active_time by x minutes
				if ($time_diff_minutes >= 5) {
					$sql = "DELETE FROM onlineusers WHERE id = '" . $id . "'";
					$del = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
					//print "it worked there is a difference of $time_diff_minutes minutes<br />";
				} else {
					//print "it did not work there is only a difference of $time_diff_minutes minutes<br />";
				}
			}
		}
	}
}

//function to convert from INET_ATON http://www.ipligence.com/en/faq/
//select INET_NTOA('3515134258');
function ipConvert($ip)
{
	$b = array(0,0,0,0);
	$c = 16777216.0;
	$ip += 0.0;
	for ($i = 0; $i < 4; ++$i) {
		$k = (int)($ip / $c);
		$ip -= $c * $k;
		$b[$i]= $k;
		$c /=256.0;
	}
	$d = join('.', $b);
	if (isset($d))
		return $d;
	return false;
}

function ipConvertLong($ip)
{
	$d = 0.0;
	$b = explode('.', $ip, 4);
	for ($i = 0; $i < 4; ++$i) {
		$d *= 256.0;
		$d += $b[$i];
	}
	if (isset($d))
		return $d;
	return false;
}

//Image functions
function checkImageSize($tmpfile, $max)
{
	//check the tmpimage file size and see if it is to big returns true if to large
	$size = filesize($tmpfile);
	if ($size > $max)
		return true;
	return false;
}

function checkAllowedExt($file)
{
	//check file for allowed extensions returns true if wrong type
	$temp = strtolower($file);
	$ext = pathinfo($temp, PATHINFO_EXTENSION);

	$allowed = array('gif', 'jpg', 'jpeg', 'png');
	if (!in_array($ext, $allowed))
		return true;
	return false;
}

function deleteUserImage($user)
{
	//look up old image path then remove the file before preceding with the new image upload
	$sql = "SELECT image FROM users WHERE user = '" . $user . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$row = sqlFetchAssoc($res);
	$del = $row["image"];
	if (!empty($del)) {
		$ext = pathinfo($del, PATHINFO_EXTENSION);
		$base = pathinfo($del, PATHINFO_FILENAME);
		$dir = pathinfo($del, PATHINFO_DIRNAME);
		$base_path = "$dir/$base";

		if (file_exists($del)) {
			//user delete own image use normal path
			unlink("$del");
			unlink("$base_path" . "_thumb" . "." . "$ext");
		} else {
			//if admin is removing then adjust the path
			unlink("../$del");
			unlink("../$base_path" . "_thumb" . "." . "$ext");
		}
		$sql = "UPDATE users SET image = ''  WHERE user = '" . $user . "'";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		return true;
	}
	return false;
}

function openImage($file)
{
	// Get extension and return it
	$ext = pathinfo($file, PATHINFO_EXTENSION);
	switch(strtolower($ext)) {
		case 'jpg':
		case 'jpeg':
			$im = @imagecreatefromjpeg($file);
			break;
		case 'gif':
			$im = @imagecreatefromgif($file);
			break;
		case 'png':
			$im = @imagecreatefrompng($file);
			break;
		default:
			$im = false;
			break;
	}
	return $im;
}

function createThumb($file, $ext, $width)
{
	$im = '';
	$im = openImage($file);

	if (empty($im)) {
		return false;
	}

	$old_x = imagesx($im);
   	$old_y = imagesy($im);

    $new_w = (int)$width;

	if (($new_w <= 0) or ($new_w > $old_x)) {
		$new_w = $old_x;
   	}

   	$new_h = ($old_x * ($new_w / $old_x));

    if ($old_x > $old_y) {
        $thumb_w = $new_w;
        $thumb_h = $old_y * ($new_h / $old_x);
    }
    if ($old_x < $old_y) {
        $thumb_w = $old_x * ($new_w / $old_y);
        $thumb_h = $new_h;
    }
    if ($old_x == $old_y) {
		$thumb_w = $new_w;
		$thumb_h = $new_h;
    }

	$thumb = imagecreatetruecolor($thumb_w,$thumb_h);

	if ($ext == 'png') {
		imagealphablending($thumb, false);
		$colorTransparent = imagecolorallocatealpha($thumb, 0, 0, 0, 127);
       	imagefill($thumb, 0, 0, $colorTransparent);
       	imagesavealpha($thumb, true);
	} elseif ($ext == 'gif') {
    	$trnprt_indx = imagecolortransparent($im);
        if ($trnprt_indx >= 0) {
        	//its transparent
           	$trnprt_color = imagecolorsforindex($im, $trnprt_indx);
           	$trnprt_indx = imagecolorallocate($thumb, $trnprt_color['red'], $trnprt_color['green'], $trnprt_color['blue']);
           	imagefill($thumb, 0, 0, $trnprt_indx);
           	imagecolortransparent($thumb, $trnprt_indx);
		}
	}

	imagecopyresampled($thumb,$im,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y);

	//choose which image program to use
	switch(strtolower($ext)) {
		case 'jpg':
		case 'jpeg':
			imagejpeg($thumb,$file);
			break;
		case 'gif':
			imagegif($thumb,$file);
			break;
		case 'png':
			imagepng($thumb,$file);
			break;
		default:
			return false;
			break;
	}

	imagedestroy($im);
    imagedestroy($thumb);
}

function moveUploadImage($path, $file, $tmpfile, $max, $user)
{
	//upload your image and give it a random name so no conflicts occour
	$rand = rand(1000,9000);
	$save_path = $path . $user . $rand . $file;
	
	//prep file for db and gd manipulation
	$bad_char_arr = array(' ', '&', '(', ')', '*', '[', ']', '<', '>', '{', '}');
	$replace_char_arr = array('-', '_', '', '', '', '', '', '', '', '', '');
	$save_path = str_replace($bad_char_arr, $replace_char_arr, $save_path);

	//move the temp file to the proper place
	if (move_uploaded_file($tmpfile, $save_path)) {
		$ext = pathinfo($save_path, PATHINFO_EXTENSION);
		$base = pathinfo($save_path, PATHINFO_FILENAME);
		$dir = pathinfo($save_path, PATHINFO_DIRNAME);
		$base_path = "$dir/$base";

		copy($save_path, "$base_path" . "_thumb" . "." . "$ext");
		createThumb("$base_path" . "_thumb" . "." . "$ext", $ext, 150);
		createThumb("$base_path" . "." . "$ext", $ext, 640);

		//chmod("$base_path" . "_thumb" . "." . "$ext", 0644);
		//chmod("$base_path" . "." . "$ext", 0644);

		return $save_path;
	}
	unlink($tmpfile);
	return false;
}

//upload the images for the members page
function uploadUserImage($path, $file, $tmpfile, $max, $user)
{
       if (empty($file))
          return false;
       if (!getimagesize($tmpfile))
          return false;
       if (checkImageSize($tmpfile, $max))
          return 1;
       if (checkAllowedExt($file))
          return 2;

	//look up old image path then remove the file before preceding with the new image upload
	$sql = "SELECT image FROM users WHERE user = '" . $user . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$row = sqlFetchAssoc($res);
	$del = $row["image"];
	if (!empty($del)) {
		$dir = pathinfo($del, PATHINFO_DIRNAME);
		$ext = pathinfo($del, PATHINFO_EXTENSION);
		$base = pathinfo($del, PATHINFO_FILENAME);
		$base_path = "$dir/$base";

		unlink("$del");
		unlink("$base_path" . "_thumb" . "." . "$ext");
	}

	//set approved status to not approved since listing was updated
	$approved = getActivationDefaults();

	$save_path = moveUploadImage($path, $file, $tmpfile, $max, $user);
	if (!empty($save_path)) {
		$sql = "UPDATE users SET approved = " . $approved . ", image = '" . $save_path . "' WHERE user = '" . $user . "' ";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

		if ($res)
			return 99;
	}
	return false;
}

//Get option information lists
function getCountryList()
{
	$sql = "SELECT * FROM country ORDER by name"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $countrylist[$c]["country_id"] = $a_row["country_id"];
		 $countrylist[$c]["name"] = $a_row["name"];
		 $countrylist[$c]["iso_code_2"] = $a_row["iso_code_2"];
		 $countrylist[$c]["iso_code_3"] = $a_row["iso_code_3"];
	++$c;
    }
	if (isset($countrylist))
		return $countrylist;
}

function getStatesList()
{
	$sql = "SELECT * FROM states ORDER by state_name"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $stateslist[$c]["state_prefix"] = $a_row["state_prefix"];
		 $stateslist[$c]["state_name"] = $a_row["state_name"];
	++$c;
    }
	if (isset($stateslist))
		return $stateslist;
}

function getTableDataList($table)
{
	$sql = "SELECT * FROM $table ORDER by $table ASC"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $records[$c]["id"] = $a_row["id"];
		 $records[$c]["$table"] = $a_row["$table"];
	++$c;
    }
	if (isset($records))
		return $records;
}

function getTotalUserCountStatistics($active_status)
{
	global $visitor_tracking;

	//check online status of listings
	if (!empty($active_status) && $active_status == 'active') {
		$sql = "SELECT user FROM users WHERE approved = 1";
	} elseif (!empty($active_status) && $active_status == 'pending') {
		$sql = "SELECT user FROM users WHERE approved !=1";
	}  elseif (!empty($active_status) && $active_status == 'activated') {
		$sql = "SELECT user FROM users WHERE activated !=1";

	//check online status of guests or registered users
	} elseif (!empty($active_status) && $active_status == 'sellers') {
		$sql = "SELECT user FROM users WHERE user_level = 2";
	} 
	if (!empty($visitor_tracking)) {
		if (!empty($active_status) && $active_status == 'online') {
			$sql = "SELECT * FROM onlineusers WHERE user != 'guest'";
		} elseif (!empty($active_status) && $active_status == 'guest') {
			$sql = "SELECT * FROM onlineusers WHERE user = 'guest'";
		}
	}

	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);
	
	if (isset($num))
		return $num;
}
?>