<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 4-20-2011 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

//include for mail class
require_once './Includes/libs/Mailer/class.phpmailer.php';

function checkSMTP() 
{
	$sql = "SELECT use_smtp FROM env_settings"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	if (!empty($res)) {
		$row = sqlFetchAssoc($res);
		return $row["use_smtp"];
	} else {
		return false;
	}
}

function getSMTPSettings() 
{
	$sql = "SELECT smtp_host,smtp_port,smtp_user,smtp_pass FROM env_settings"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$row = sqlFetchAssoc($res);

	//get mail settings from env table in DB
	$settings["Host"]       = $row["smtp_host"];  // SMTP server
	$settings["SMTPDebug"]  = 0; //SMTP debug information (for testing)
								 // 1 = errors and messages
								 // 2 = messages only
	$settings["Port"]       = $row["smtp_port"];  // set the SMTP port
	$settings["Username"]   = $row["smtp_user"];  // SMTP account username
	$settings["Password"]   = $row["smtp_pass"]; 

	if (!empty($settings)) {
		return $settings;
	} else {
		return false;
	}
}

//Mail functions $email,$subject,$body,$admin_name,$admin_email
function sendEmail($ToEmail,$Subject,$Body,$From,$FromEmail)
{
	//$ver = floatval(phpversion());
	$Body = preg_replace("!<br \/>!","\n",$Body);

	/*$headers = '';
	$headers .="Content-Type: text/plain; charset=\"UTF-8\"\n";
	$headers .="From: $From <$FromEmail>\n";
	$headers .="Reply-To: <$FromEmail>\n";
	$headers .="Return-Path: <$FromEmail> \n";
	$headers .="X-Sender: <$FromEmail>\n";
	$headers .="X-Mailer: PHP-$ver \n";
	$headers .="X-Priority: 3\n"; //1 UrgentMessage, 3 Normal*/

	//mail($ToEmail,$Subject,wordwrap($Body),$headers);

	$mail = new PHPMailer();
	$mail->ContentType = 'text/plain';
	
	//setup mailer enviorment
	$mail->IsHTML(false);
	$mail->CharSet = DOCUMENT_CHARSET;
	
	//setup to and from
	$mail->AddAddress($ToEmail);
	$mail->SetFrom("$FromEmail", "$From");
	$mail->AddReplyTo("$FromEmail", "$From");
	
	//check if smtp and pre accordingly
	if (checkSMTP()) {
		$mail->IsSMTP();                           // telling the class to use SMTP
		$mail->SMTPAuth   = true;                  // enable SMTP authentication
		
		$mailer = getSMTPSettings();               // get local settings from function
		$mail->Host       = $mailer["Host"]; 	   // SMTP server
		$mail->SMTPDebug  = $mailer["SMTPDebug"];  // enables SMTP debug information (for testing)
	    	                                       // 1 = errors and messages
	        	                                   // 2 = messages only
	
		$mail->Port       = $mailer["Port"];       // set the SMTP port for the GMAIL server
		$mail->Username   = $mailer["Username"];   // SMTP account username
		$mail->Password   = $mailer["Password"];   // SMTP account password
	}
	
	//prep message and send
	$mail->Subject = "$Subject";
	$mail->Body = "$Body";
	//$mail->MsgHTML($Body);
	
	$mail->Send();
	
	/*if(!$mail->Send()) {
		echo "Mailer Error: " . $mail->ErrorInfo;
	} else {
		echo "Message sent!";
	}*/
}

//check contact us form for submission errors
function checkSubmitForm($from_email,$from_name,$subject,$msg,$captcha,$security_code)
{
	$error = '';
	if (!validateEmail($from_email)){
		$error[] = 1;
	}
	if (empty($from_name)) {
		$error[] = 2; 
	}
	if (empty($subject)) {
		$error[] = 3;
	}
	if (empty($msg)) {
		$error[] = 4;
	}
	if (!empty($security_code) && $security_code !== $captcha) {
		$error[] = 5;
	}
	if (empty($captcha)) {
		$error[] = 6;
	} 
	if ($error) {
		return $error;
	} else {
		return 99;
	}
}

?>