<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 09-23-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once 'Includes/configs/admin_config.php';
require_once 'Includes/configs/admin_functions.php';

if (file_exists("./Includes/language/$site_lang/admin_global.php")) {
	include_once "./Includes/language/$site_lang/admin_global.php";
} else {
	include_once "./Includes/language/en/admin_global.php";
}
if (file_exists("../Includes/language/$site_lang/global.php")) {
	include_once "../Includes/language/$site_lang/global.php";
} else {
	include_once "../Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
} else {
	include_once "./Includes/language/en/".basename(__FILE__)."";
}

//reset search session
$paginate = new SmartyPaginate();
$paginate->disconnect();

//set default parameters for queries
$id = 'all';
$addOnSQL = '';
$sort = 'ORDER BY approved,id DESC';

$smarty = new Smarty;

//check that your logged in
if (isset($_SESSION["logged_in"])) {
	//User not an administrator, redirect to main login page automatically.
	if (!checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
		header("Location: ../login.php");
		exit();
	} else {		
		//set variables for logged in
		session_regenerate_id();
		$smarty->assign("logged_in",1);
		$smarty->assign("username",$_SESSION["user"]);
	}

	//Administrator is viewing page, so display all
	if (isset($_SESSION["admin"])) {
		$smarty->assign("admin",1);

		//statistics sections for users and guests
		$smarty->assign("total_registered_user_count",getTotalUserCountStatistics('active'));
		$smarty->assign("total_pending_user_count",getTotalUserCountStatistics('pending'));
		$smarty->assign("total_sellers_user_count",getTotalUserCountStatistics('sellers'));

		if (!empty($visitor_tracking)) {
			$smarty->assign("visitor_tracking",1);
			$smarty->assign("total_online_user_count",getTotalUserCountStatistics('online'));
			$smarty->assign("total_guest_online_user_count",getTotalUserCountStatistics('guest'));
		}
	}
} else {
	header("Location: ../login.php");
	exit();
}

$smarty->assign("admin_center",1);
$smarty->display('admin.tpl');
?>