<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 09-24-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once 'Includes/configs/admin_config.php';
require_once 'Includes/configs/admin_functions.php';

if (file_exists("./Includes/language/$site_lang/admin_global.php")) {
	include_once "./Includes/language/$site_lang/admin_global.php";
} else {
	include_once "./Includes/language/en/admin_global.php";
}
if (file_exists("../Includes/language/$site_lang/global.php")) {
	include_once "../Includes/language/$site_lang/global.php";
} else {
	include_once "../Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
} else {
	include_once "./Includes/language/en/".basename(__FILE__)."";
}

function getDirs($dir)
{
	// prepare to read directory contents	
	if (is_dir($dir)) {
		if ($dh = opendir($dir)) {
			$c="0";
			while (($file = readdir($dh)) !== false) {
				if ($file != '.' && $file != '..' && $file != 'templates_c' && $file != 'cache') {
					if (filetype($dir . $file) == "dir") {
 						$files[$c]["folder"] = $file;
						//print "$file : filetype: $c <br />\n";
					++$c;
					}
				}
			}
			closedir($dh);
			return $files;
		}
	}
}

$smarty = new Smarty;

//check that your logged in
if (isset($_SESSION["logged_in"])) {
	//User not an administrator, redirect to main login page automatically.
	if (!checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
		header("Location: ../login.php");
		exit();
	} else {
		//set variables for logged in
		session_regenerate_id();
		$smarty->assign("logged_in",1);
		$smarty->assign("username",$_SESSION["user"]);
	
		//Administrator is viewing page, so display all
		if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
			$_SESSION["admin"] = 1;	
	
			if (isset($_SESSION["admin"])) {
				$smarty->assign("admin",1);
	
				//setup template defaults for lang choices and template choices
				$smarty->assign("site_lang_choices",getDirs('../Includes/language/'));
				$smarty->assign("template_choices",getDirs('../templates/'));
	
				//setup timezones required > PHP 5.2
				$smarty->assign("timezones_list",DateTimeZone::listIdentifiers());
	
				if (isset($_POST["submit"])) {
					$_POST = codeClean($_POST);
	
					$res = updateEnv($_POST);
					// Update was successful
					if ($res == 99) {
						$smarty->assign("success",ENV_UPDATE_SUCCESS);
	
						//when POST the settings need to be updated on page
						$env = getEnvSettings();
						foreach ($env as $field => $value ) {
							$smarty->assign("$field",$value);
						}
					}
				} else {   
					//assign env settings to the template
					foreach ($env as $field => $value ) {
						$smarty->assign("$field",$value);
					}
				}
			}
		}
	}
} else {
	header("Location: ../login.php");
	exit();
}

$smarty->assign("settings",1);
$smarty->display('settings.tpl');
?>