<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 12-31-2011 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once './Includes/configs/functions.php';
require_once './Includes/libs/Smarty.class.php';

if (file_exists("./Includes/language/$site_lang/global.php")) {
	include_once "./Includes/language/$site_lang/global.php";
} else {
	include_once "./Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
}

$smarty = new Smarty;
$smarty->force_compile = $force_compile_enabled;

$file = basename(__FILE__, ".php");
if (file_exists("templates/$template/$file.tpl")) {
	$smarty->template_dir="templates/$template";
} else {
	$smarty->template_dir="templates/Default";
}

if (isset($_GET["logoff"])) {
	logoff();
	exit();
}

//Check if single user mode 1 or multi-user mode 0
if ($site_mode == 0) {
	$smarty->assign("site_mode",1);
}
//Check if single user mode 1 or multi-user mode 0
if ($site_mode == 1) {
	$smarty->assign("single_mode",1);
}

if (isset($_SESSION["user"]) && isset($_SESSION["pass"])) {
	if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
    	session_write_close();
		header("Location: admin/admin.php");
	} elseif (isset($_SESSION["user"])) {
		session_write_close();
		header("Location: member.php");
	}
}

$user = "";
$pass = "";

//check for email verification if code is submitted
if ($use_verify_email) {
	if (isset($_GET["verify"])) {
		$confirmation_id = codeClean($_GET["verify"]);
		$res = activateProfile($confirmation_id);
		if ($res == 99) {
			//account email validation was successful
			$smarty->assign("success",ACCOUNT_VALIDATION_SUCCESS);
		} else {
			//there was an error with the account email validation
			if ($res == 1) {
				$smarty->assign("error_message",INVALID_CONFIRMATION_ID_ERROR);
			}
			if ($res == 2) {
				$smarty->assign("error_message",USER_ALREADY_ACTIVATED);
			}
			if ($res == 3) {
				$smarty->assign("error_message",USER_ALREADY_EXIST_ERROR);
			}
			if ($res == 4) {
				$smarty->assign("error_message",INVALID_TIMESTAMP_ERROR);
			}
			if ($res == 5) {
				$smarty->assign("error_message",INVALID_USER_ID_ERROR);
			}
		}
	}
}

if (isset($_POST["submit"]) && $_POST["submit"] == LOGIN) {
	$_POST = codeClean($_POST);
	if (validateUsername($_POST["user"])) {
		if (verifyLogin($_POST["user"],$_POST["pass"])) {
			session_regenerate_id();
			$_SESSION["user"] = $_POST["user"];

			//get md5 password hashes with salt and then set as session password 
			$salt = 's+(_a*';
			$md5pass = md5($_POST["pass"].$salt);
        	$_SESSION["pass"] = "$md5pass";
			lastActive($_SESSION["user"]);
			$_SESSION["logged_in"] = 1;

			//set persistant cookie for remember me function
			if (isset($_POST["remember"])) {
	   			setcookie("user", $_SESSION["user"], time() + (60*60*24*30));
	   			setcookie("pass", "$md5pass", time() + (60*60*24*30));
			}

			if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
				session_regenerate_id();
				$_SESSION["admin"] = 1;
				header("Location: admin/admin.php");
			} elseif (checkIfSeller($_SESSION["user"],$_SESSION["pass"])) {
				session_regenerate_id();
				$_SESSION["seller"] = 1;
				header("Location: member.php"); 
			} else {
				session_regenerate_id();
				header("Location: member.php");
			}

		} else {
			//there was an error with your login
			$smarty->assign("error_message",LOGIN_ERROR);
		}
	} else {
		//username not validated
		if ($_POST["user"] == "") {
			$smarty->assign("user_error",1);
			$smarty->assign("error_message",BLANK_USERNAME);
		} else {
			$smarty->assign("error_message",LOGIN_ERROR);
		}
	}
}

if (isset($_POST["remember"])) {
	$smarty->assign("formremember",1);
	//$smarty->assign("user_error",$_POST["user"]);
}

$smarty->assign("login",1);
$smarty->display('login.tpl'); 
?>