<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 04-20-2011 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once './Includes/configs/functions.php';
require_once './Includes/configs/mail.inc.php';
require_once './Includes/libs/Smarty.class.php';

if (file_exists("./Includes/language/$site_lang/global.php")) {
	include_once "./Includes/language/$site_lang/global.php";
} else {
	include_once "./Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
}

$smarty = new Smarty;
$smarty->force_compile = $force_compile_enabled;

$file = basename(__FILE__, ".php");
if (file_exists("templates/$template/$file.tpl")) {
	$smarty->template_dir="templates/$template";
} else {
	$smarty->template_dir="templates/Default";
}

//Check if single user mode 1 or multi-user mode 0
if ($site_mode == 1 && !isset($_SESSION["admin"])) {
	header("Location: login.php");
	exit();
} elseif ($site_mode == 0) {
	$smarty->assign("site_mode",1);
}

//The user is already logged in, not allowed to register.
//redirect to member home
$status = checkPrivs();
$smarty->assign("$status",1);

if (isset($_SESSION["logged_in"])){
	$smarty->assign("logged_in",1);
	if (!isset($_SESSION["admin"])){
		header("Location: member.php");
		exit();
	}
}

//Multi-user mode. Allow new users to register
if (isset($_POST["submit"])) {
	$_POST = codeClean($_POST);
	if (isset($_POST{"agree"})) {
		$_POST{"agree"} = $_POST{"agree"};
	} else {
		$_POST{"agree"} = '';
	}
	$res = registerUser($_POST["user"], $_POST["pass"], $_POST["email"], $_POST["company_name"], $_POST["first_name"], $_POST["last_name"], $_POST["phone"], $_POST["alt_phone"], $_POST["fax"], $_POST["country"], $_POST["address"], $_POST["city"], $_POST["state"], $_POST["zip"], $_POST["agree"]);

	// Registration was successful
	if ($res == 99) {
		if ($use_verify_email) {
			$smarty->assign("success",REGISTRATION_SUCCESS_VERIFY);
		} else {
			$smarty->assign("success",REGISTRATION_SUCCESS);
		}
	} else {
		//keep users data in the form for resubmission
		$_POST = codeClean($_POST);
		$smarty->assign("formagree",$_POST["agree"]);
		$smarty->assign("formemail",viewOnPage($_POST["email"]));
		$smarty->assign("formuser",viewOnPage($_POST["user"]));
		$smarty->assign("company_name",viewOnPage($_POST["company_name"])); 
		$smarty->assign("first_name",viewOnPage($_POST["first_name"])); 
		$smarty->assign("last_name",viewOnPage($_POST["last_name"])); 
		$smarty->assign("phone",$_POST["phone"]);
		$smarty->assign("alt_phone",$_POST["alt_phone"]);
		$smarty->assign("fax",$_POST["fax"]);
		$smarty->assign("address",viewOnPage($_POST["address"]));
		$smarty->assign("city",viewOnPage($_POST["city"]));
		$smarty->assign("state",$_POST["state"]);
		$smarty->assign("zip",$_POST["zip"]);
 
		//Errors during registration so build the list of errore
		$content = '';
		if (in_array(1,$res)) {
			$content .= "" . ALREADY_USER_ERROR ."<br />";
			$smarty->assign("user_error",1);
		}
		if (in_array(2,$res)) {
			$content .= "" . VALIDATE_EMAIL_ERROR ."<br />";
			$smarty->assign("mail_error",1);		
		}
		if (in_array(3,$res)) {
			$content .= "" . VALIDATE_USER_ERROR ."<br />";
			$smarty->assign("user_error",1);
		}
		if (in_array(4,$res)) {
			$content .= "" . ALREADY_EMAIL_ERROR ."<br />";
			$smarty->assign("mail_error",1);
		}
		if (in_array(5,$res)) {
			$content .= "" . CHECK_AGREE_ERROR ."<br />";
			$smarty->assign("agree_error",1);
		}
		if (in_array(6,$res)) {
			$content .= "" . PHONE_ERROR ."<br />";
			$smarty->assign("phone_error",1);
		}
		if (in_array(7,$res)) {
			$content .= "" . FIRST_NAME_ERROR ."<br />";
			$smarty->assign("first_name_error",1);
		}
		if (in_array(8,$res)) {
			$content .= "" . LAST_NAME_ERROR ."<br />";
			$smarty->assign("last_name_error",1);
		}
		if (in_array(9,$res)) {
			$content .= "" . SUPPLY_PASSWORD ."<br />";
			$smarty->assign("pass_error",1);
		}
		$smarty->assign("error_message",$content);
	}
}

if (!empty($use_user_location)) {
	$smarty->assign("use_user_location",$use_user_location);
}

$smarty->assign("countrylist",getCountryList());
//$smarty->assign("stateslist",getStatesList());

$smarty->assign("register",1);
$smarty->display('register.tpl');
?>